const path = require("path");
const { CheckerPlugin } = require("awesome-typescript-loader");
const { TsConfigPathsPlugin } = require("awesome-typescript-loader");
const CopyWebpackPlugin = require("copy-webpack-plugin");
const CleanWebpackPlugin = require("clean-webpack-plugin");

module.exports = {
    entry: "./src/ts/main.ts",
    output: {
        filename: "./src/app.bundle.js",
        path: path.resolve(__dirname, ".")
    },
    resolve: {
        extensions: [
            ".ts"
        ]
    },
    devtool: "source-map",
    module: {
        loaders: [
            {
                test: /\.ts$/,
                loader: "awesome-typescript-loader"
            }
        ]
    },
    plugins: [
        new CleanWebpackPlugin(
            [
                "dist"
            ],
            {
                verbose: false,
                exclude: [
                    ".gitkeep"
                ]
            }
        ),
        new CheckerPlugin(),
        new TsConfigPathsPlugin(),
        new CopyWebpackPlugin(
            [
                {
                    context: "./src",
                    from: "**/*",
                    to: "./dist/",
                    ignore: [
                        "ts/**/*"
                    ]
                }
            ]
        ),
        //@todo Doesn't remove app.bundle.js??
        // new CleanWebpackPlugin(
        //     [
        //         "src/app.bundle.js*"
        //     ],
        //     {
        //         // verbose: false
        //     }
        // ),
    ]
};